; USB_Autorun_WMI V1.1
; von M.Schrder 28.09.2008
; Dank an Xenobiologist von AutoIt.de fr die Idee der WMI-Event-Abfrage
;
; Das Programm wird z.B. per Autostart gestartet und wertet auf
; Wechseldatentrgern eine ggf. vorhandene "Autorun.inf" aus und
; startet gewnschte Dateien oder Programme beim Hinzufgen und
; Entfernen des Datentrgers.
;
; Eine "Autorun.inf" kann wie folgt aussehen:
; 	[autorun]
; 	icon=icon.ico
; 	open=start.exe
; 	close=stop.exe

#NoTrayIcon
#compiler_icon=USB_Autorun.ico
#compiler_outfile=USB_Autorun.exe
Opt("TrayMenuMode",1)
Opt("TrayOnEventMode",1)
Opt("MustDeclareVars",1)

Dim $WMI, $Events, $Event, $time, $StopTimeout = 10000
Dim $start, $stop, $search, $file, $trayexit, $pid

; ggf. alte STOP-Dateien lschen
$search = FileFindFirstFile(@TEMPDIR & "\USBARS_*.*")  
If $search <> -1 Then
    While 1
    	$file = FileFindNextFile($search) 
    	If @error Then ExitLoop
    	FileDelete(@TEMPDIR & "\" & $file)
	Wend
EndIf
FileClose($search)

; Neues Traymenue zum Beenden anlegen
$trayexit = TrayCreateItem("USB Autorun beenden")
TrayItemSetOnEvent(-1,"ExitEvent")
TraySetIcon("USB_Autorun.ico")
TraySetToolTip ("USB Autorun")
TraySetState()

$WMI = ObjGet("winmgmts:\\.\root\cimv2")
$Events = $WMI.ExecNotificationQuery ("Select * From __InstanceOperationEvent Within 5 Where " & "TargetInstance isa 'Win32_LogicalDisk'")
While 1
	$Event = $Events.NextEvent
	If $Event.TargetInstance.DriveType = 2 Then
		Select
		
			; Laufwerk wurde hinzugefgt
			Case $Event.Path_.Class()="__InstanceCreationEvent"
				If DriveStatus($Event.TargetInstance.DeviceId) = "READY" Then
					$start = ""
					$stop = ""
					If FileExists($Event.TargetInstance.DeviceId & "\Autorun.inf") then
						$start = IniRead($Event.TargetInstance.DeviceId & "\Autorun.inf","autorun","open","")
						$stop = IniRead($Event.TargetInstance.DeviceId & "\Autorun.inf","autorun","close","")
						If $start <> "" Then Run($Event.TargetInstance.DeviceId & "\" & $start,"",$Event.TargetInstance.DeviceId & "\")
						If $stop <> "" And FileExists($Event.TargetInstance.DeviceId & "\" & $stop) Then
							; Stop-Datei fr die sptere Ausfhrung nach %TEMP kopieren und umbenennen
							FileCopy($Event.TargetInstance.DeviceId & "\" & $stop, @TempDir & "\USBARS_" & StringLeft($Event.TargetInstance.DeviceId,1) & StringRight($stop,4))
						EndIf
					EndIf
				EndIf
			
			; Laufwerk wurde entfernt	
			Case $Event.Path_.Class()="__InstanceDeletionEvent"
				$search = FileFindFirstFile(@TEMPDIR & "\USBARS_" & StringLeft($Event.TargetInstance.DeviceId,1) & ".*")  
				If $search <> -1 Then
    				While 1
    					$file = FileFindNextFile($search) 
    					If @error Then ExitLoop
    					$time = TimerInit()
    					$pid = Run(@TEMPDIR & "\" & $file)
    					; wartet auf das Beenden des Programms bzw. bis zum Timeout
    					; und versucht dann die Datei aus dem %TEMP-Ordner zu lschen
    					While ProcessExists($pid) And TimerDiff($time) < $StopTimeout
    						Sleep(100)
    					Wend
    					FileDelete(@TEMPDIR & "\" & $file)
					Wend
				EndIf
				FileClose($search)
		EndSelect
	EndIf
WEnd

Func ExitEvent()
	Exit
EndFunc